/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package client;

import abstractFactory.AbstractFactory;
import abstractProductA.Form;
import abstractProductB.Data;
import abstractProductC.Controller;

/**
 *
 * @author Luka
 */
public class Client {
    
    private AbstractFactory abstractFactory;
    private ComplexProduct complexProduct;
    
    public Client(AbstractFactory abstractFactory) {
        this.abstractFactory = abstractFactory;
    }
    
    public void createProduct() {
        Form view = abstractFactory.createView();
        Data model = abstractFactory.createModel();
        Controller controller = abstractFactory.createController(model, view);
        complexProduct = new ComplexProduct(view, model, controller);
        complexProduct.useProduct();
    }
    
}

class ComplexProduct {
    
    private Form view;
    private Data model;
    private Controller controller;

    public ComplexProduct(Form view, Data model, Controller controller) {
        this.view = view;
        this.model = model;
        this.controller = controller;
    }
    
    public void useProduct() {
        controller.showView();
    }
    
}
