/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractProductA;

import abstractProductA.Controller;
import abstractProductB.DatabaseBroker;
import domain.Product;
import abstractProductC.Form;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.BigDecimal;

/**
 *
 * @author Luka
 */
public class Controller1 extends Controller {

    public Controller1(DatabaseBroker databaseBroker, Form form) {
        this.databaseBroker = databaseBroker;
        this.form = form;
        setListeners();
    }

    /**
     *
     */
    @Override
    public void setListeners() {
        form.getPanel().getBtnCreate().addActionListener(new ListenerCreate(this));
        form.getPanel().getBtnEdit().addActionListener(new ListenerEdit(this));
        form.getPanel().getBtnFind().addActionListener(new ListenerFind(this));
        form.getPanel().getBtnDelete().addActionListener(new ListenerDelete(this));
    }

    public void populateProductFromForm() {
        product = new Product();
        product.setId(new Long(form.getPanel().getId()));
        product.setName(form.getPanel().getProductName());
        product.setPrice(new BigDecimal(form.getPanel().getPrice()));
    }

    public void populateFormFromProduct() {
        form.getPanel().setId(product.getId().toString());
        form.getPanel().setProductName(product.getName());
        form.getPanel().setPrice(product.getPrice().toString());
    }

    public void clear() {
        form.getPanel().setId("0");
        form.getPanel().setName("Product name");
        form.getPanel().setPrice("0");
        form.getPanel().setMessage("");
    }

    public void createProduct() {
        product = new Product();
        product.setId(databaseBroker.getNextId());
        databaseBroker.add(product);
        populateFormFromProduct();
        form.getPanel().setMessage("Product created.");
    }

    public void findProduct() {
        try {
            populateProductFromForm();
            product = (Product) databaseBroker.find(product);
            populateFormFromProduct();
            form.getPanel().setMessage("Product found.");
        } catch (Exception ex) {
            clear();
            form.getPanel().setMessage("Product could not be found.");
        }
    }

    public void editProduct() {
        populateProductFromForm();
        databaseBroker.edit(product);
        form.getPanel().setMessage("Product edited.");
    }

    public void deleteProduct() {
        populateProductFromForm();
        databaseBroker.delete(product);
        clear();
        form.getPanel().setMessage("Product deleted.");
    }

}

class ListenerCreate implements ActionListener {

    private Controller1 controller;

    public ListenerCreate(Controller1 controller) {
        this.controller = controller;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        controller.createProduct();
    }

}

class ListenerFind implements ActionListener {

    private Controller1 controller;

    public ListenerFind(Controller1 controller) {
        this.controller = controller;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        controller.findProduct();
    }

}

class ListenerEdit implements ActionListener {

    private Controller1 controller;

    public ListenerEdit(Controller1 controller) {
        this.controller = controller;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        controller.editProduct();
    }

}

class ListenerDelete implements ActionListener {

    private Controller1 controller;

    public ListenerDelete(Controller1 controller) {
        this.controller = controller;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        controller.deleteProduct();
    }

}
