/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package client;

import abstractFactory.AbstractFactory;
import abstractProductA.Controller;
import abstractProductB.DatabaseBroker;
import abstractProductC.Form;

/**
 *
 * @author Luka
 */
public class Client {

    private AbstractFactory abstractFactory;
    private ComplexProduct complexProduct;

    public Client(AbstractFactory abstractFactory) {
        this.abstractFactory = abstractFactory;
    }

    public void createProduct() {
        Form form = abstractFactory.createForm();
        DatabaseBroker databaseBroker = abstractFactory.createDatabaseBroker();
        Controller controller = abstractFactory.createController(form, databaseBroker);
        complexProduct = new ComplexProduct(form, databaseBroker, controller);
        complexProduct.useProduct();
    }

    class ComplexProduct {

        private Form form;
        private DatabaseBroker databaseBroker;
        private Controller controller;

        public ComplexProduct(Form form, DatabaseBroker databaseBroker, Controller controller) {
            this.form = form;
            this.databaseBroker = databaseBroker;
            this.controller = controller;
        }

        public void useProduct() {
            controller.showForm();
        }

    }

}
